#define _GNU_SOURCE

#include "ch_time_and_mod_dir.h"
#include "cp.h"
#include "filefrag_custom.h"
#include "global.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include <errno.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>

/*******************************************************************************
*******************************************************************************/
void dir_traverse(const char *target, const struct stat *target_stat, const _Bool target_flag)
{
	if(chdir(target) == -1)
	{
		perror("chdir");
		return;
	}

	DIR *dp = NULL;
	struct dirent *entry = NULL;

	if((dp = opendir(".")) != NULL)
	{
		while((entry = readdir(dp)) != NULL)
		{
			// strcmpは等しければ0を返す（0は偽）
			if(strcmp(entry->d_name, ".") && strcmp(entry->d_name, ".."))
			{
				_Bool stat_flag = false;
				struct stat stat_buf;
				int from_extents;

				switch(entry->d_type)
				{
				case DT_REG:
					from_extents = filefrag_custom(entry->d_name);

					if(from_extents > 1)
					{
						cp(entry->d_name, from_extents);

						if(target_flag == true)
						{
							ch_time_and_mod_dir(".", target_stat);
						}
					}
					break;

				case DT_DIR:
					if(stat(entry->d_name, &stat_buf) == -1)
					{
						perror("stat");
						stat_flag = false;
					}
					else
					{
						current_working_directory = entry->d_name;
						current_stat = &stat_buf;

						stat_flag = true;
					}

					// 再帰
					if(stat_flag == true)
					{
						dir_traverse(entry->d_name, &stat_buf, true);
					}
					else
					{
						dir_traverse(entry->d_name, &stat_buf, false);
					}

					if(chdir("..") == -1)
					{
						perror("chdir");
						exit(EXIT_FAILURE);
					}
					else
					{
						current_working_directory = entry->d_name;
						current_stat = &stat_buf;
					}

					if(stat_flag == true)
					{
						ch_time_and_mod_dir(entry->d_name, &stat_buf);
					}
					break;
				}
			}
		}
		if(closedir(dp) == -1)
		{
			perror("closedir");
		}
	}
	else
	{
		perror("opendir");
	}
}
